/*
   test.cc
  Stefan Gieseke 2005
  simple testprogram to test functionality of LHAPDFWrap class, 
  a C++ wrapper for the LHAPDF package. 
  use as a template for your program. 

  
  Adapted for lhapdfv5 etc.. by Mike Whalley
 */

#include <iostream>
#include <string>
#include "LHAPDFWrap.h"

using namespace std;

int main() {
  int subset = 0;
  char name[160];
  string byname = "../PDFsets/MRST2004qed.LHgrid";
//  string byname = "../PDFsets/MRST2004nlo.LHgrid";
  strcpy(name,byname.c_str());
//  LHAPDFWrap pdf = LHAPDFWrap(name,subset);
//  LHAPDFWrap pdf = LHAPDFWrap(name);
  LHAPDFWrap pdf = LHAPDFWrap();
//  pdf.initPDFSetByName(name);
  pdf.initPDFSet(name);
  pdf.initPDF(subset);
  double x = 0.01, Q = 10.0, Q2 = 100.0, mz=91.2;

    cout <<"alphas(mz) = "<<pdf.alphasPDF(mz) <<endl;
    cout <<"qcdlam4    = "<<pdf.getLam4(subset) <<endl;
    cout <<"qcdlam5    = "<<pdf.getLam5(subset) <<endl;
    cout <<"orderPDF   = "<<pdf.getOrderPDF() <<endl;
    cout <<"xmin       = "<<pdf.getXmin(subset) <<endl;
    cout <<"xmax       = "<<pdf.getXmax(subset) <<endl;
    cout <<"q2min      = "<<pdf.getQ2min(subset) <<endl;
    cout <<"q2max      = "<<pdf.getQ2max(subset) <<endl;
    cout <<"orderalfas = "<<pdf.getOrderAlphaS() <<endl;
    cout <<"num flav   = "<<pdf.getNf() <<endl;
    cout <<"name       = "<<name <<endl;
    cout <<"number     = "<<pdf.numberPDF() <<endl;
    cout <<endl;
//    pdf.extrapolate();
    int number = pdf.numberPDF();
    
    for (int n=0; n<number+1; n++){
     cout <<"Set number : " << n << endl; 
     pdf.initPDF(n);
     for (int ix=1; ix<11; ix++){
       x = (ix - 0.5) /10.0;
       Q = 10.0;
       Q2 = Q*Q;
       int f = 0;
       cout << f << " " << x << " " << Q << " " << pdf.xfxphoton(x,Q,f) << endl;
//       cout << f << " " << x << " " << Q << " " << pdf.xfx(x,Q,f) << endl;
     }
    }
  cout << "----------------------------------------"
       << "----------------------------------------" << endl
       << " test: checking class LHAPDFWrap with package " << endl
       << name << endl
       << " set number " << subset << "/" << pdf.numberPDF() << endl;
  cout << " - pdf.getdescription() gives -----------"
      << "----------------------------------------" << endl;
  pdf.getDescription();
  
  return 0;
}
